/*
 * Label.java 
 *
 * History: (99/10/22) Version number 0.1 released
 *	    (99/11/07) Version number 0.11 released
 *          (99/11/16) align added
 *
 *          2000-01-23 SH getText () added 
 *
 * Copyright 1999 by Stefan Haustein & Michael Kroll
 * 
 * stefan.haustein@trantor.de
 * michael.kroll@trantor.de
 *
 * All rights reserved.
 *
 * NO WARRANTY
 *
 *  1. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO
 *  WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE
 *  LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
 *  HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT
 *  WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT
 *  NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE
 *  QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
 *  PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY
 *  SERVICING, REPAIR OR CORRECTION.
 * 
 *  2. IN NOq EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
 *  WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
 *  MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE
 *  LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
 *  INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
 *  INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
 *  DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU
 *  OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY
 *  OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
 *  ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * 
 *  END OF TERMS AND CONDITIONS */


package java.awt;

import java.util.*;
import java.awt.event.*;

public class Label extends Component {  
	
    int minW;
    int minH;
    String text;
    int align;

    public static final int LEFT = 0;
    public static final int CENTER = 1;
    public static final int RIGHT = 2;

    public Label () {
	this ("", LEFT);
    }
    

    public Label (String s) {
	this (s, LEFT);
    }

    public Label (String s, int align) {
	this.align = align;
	setText (s);
	h = minH;
	w = minW;
    }
  

    public Dimension getMinimumSize () {
	return new Dimension (minW, minH);
    }
    
    
    public String getText () {
	return text;
    }
    
    
    public void paint(Graphics g) {
	int x0 = 0;
	if (align == CENTER) x0 = (w-minW)/2;
	else if (align == RIGHT) x0 = w-minW;
	
	g.drawString (text, x0, h/2 + 5); 
    }
    

    public void setText (String s) {
	text = s;
	
	minW = com.sun.kjava.Graphics.getWidth (s);
	minH = com.sun.kjava.Graphics.getHeight (s);
	
	repaint ();
    }
}
